# 圧縮対象のファイルがあるデスクトップのパス --- (※1)
$desktopPath = [System.Environment]::GetFolderPath('Desktop')
# 1年以上更新されていないファイルを検索
$oneYearAgo = (Get-Date).AddYears(-1)
$filesToCompress = Get-ChildItem -Path $desktopPath | Where-Object { $_.LastWriteTime -lt $oneYearAgo }
# 圧縮するファイルのリストを作成
$filesToCompressList = $filesToCompress.FullName
# 圧縮ファイルの名前を指定（例: "DesktopArchive.zip"）
$archiveName = "DesktopArchive.zip"
$archivePath = Join-Path -Path $desktopPath -ChildPath $archiveName
# ファイルを圧縮
if ($filesToCompress.Count -gt 0) {
    Compress-Archive -Path $filesToCompressList -DestinationPath $archivePath
    Write-Host "ok"
    # 圧縮後、元のファイルを削除 --- (※2)
    # Remove-Item -Path $filesToCompressList -Force
    # Write-Host "removed"
} else {
    Write-Host "not found"
}
