import openai

# クライアントを生成
client = openai.OpenAI()

# 会話履歴を保持する変数 --- (*1)
messages = []

# APIを呼び出す関数 --- (*2)
def call_chatgpt_chat(user_text):
    # 会話履歴にユーザーの入力を追加 --- (*3)
    messages.append({'role': 'user', 'content': user_text})
    # APIを呼び出す --- (*4)
    completion = client.chat.completions.create(
        model='gpt-3.5-turbo',
        messages=messages)
    # 会話履歴を追加 --- (*5)
    res = completion.choices[0].message.content
    messages.append({'role': 'assistant', 'content': res})
    return res

# ユーザーからの入力を連続で尋ねる --- (*6)
while True:
    user = input('あなた: ')
    # チャットを終了する?
    if user == 'quit' or user == 'exit':
        break
    if user == '': continue
    # ChatGPTを呼び出す --- (*7)
    res = call_chatgpt_chat(user)
    print('AI: ' + res)
